
<head>
    <title>提现数据</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 0;
        }
    .center {
        text-align: center;
    }
    .product-names-cell {
        max-width: 500px;
        padding: 10px;
        border: 1px solid #ccc;
        font-size: 14px;
        color: #333;
        border-radius: 6px;
        display: inline-block;
        word-wrap: break-word;
    }
        .table-container {
            max-height: 700px; 
            overflow-y: auto; 
        }
        table {
            border-collapse: collapse;
            width: 100%;
        }
        th, td {
            border: 1px solid #dddddd;
            text-align: left;
            padding: 8px;
        }
        th {
            background-color: #f2f2f2;
        }
        tr:nth-child(even) {
            background-color: #f2f2f2;
        }
        tr:hover {
            background-color: #ddd;
        }
        h1 {
            text-align: center;
        }
        @media (max-width: 768px) {
            table {
                font-size: 14px;
            }
            th, td {
                padding: 6px;
            }
        }
.img-fluid {
    max-height: 100%; 
    max-width: 100%; 
    display: block; 
    margin: 0 auto; 
}
.pending {
    background-color: #FFD700; 
    color: #333; 
    padding: 5px 10px; 
    border-radius: 5px; 
    display: inline-block; 
}
.approved {
    background-color: #008000; 
    color: #fff; 
    padding: 5px 10px;
    border-radius: 5px;
    display: inline-block;
}
.rejected {
    background-color: #FF0000; 
    color: #fff; 
    padding: 5px 10px;
    border-radius: 5px;
    display: inline-block;
}
.discount-type {
        font-weight: bold;
        text-align: center;
        padding: 10px;
        border: 1px solid #ccc;
}
    .discount-label {
        display: inline-block;
        padding: 5px 10px;
        border-radius: 5px;
        font-size: 14px;
    }
    .percent-discount {
        background-color: #ffbc21;
        color: #333;
    }
    .fixed-discount {
        background-color: green;
        color: white;
    }
    .ali-discount {
        background-color: #007bff;
        color: #fff;
    }
    .wx-discount {
        background-color: green;
        color: white;
    }
    .qq-discount {
        background-color: red;
        color: white;
    }
    .bank-discount {
        background-color: #d0b03e;
        color: white;
    }
.pagination {
    text-align: right; 
    margin-top: 20px;
}
.pagination-link {
    margin: 0 5px;
    text-decoration: none;
    color: #333;
    border: 1px solid #ccc;
    padding: 5px 10px;
    border-radius: 5px;
}
.jump-input {
    width: 40px;
    padding: 2px;
    text-align: center;
}
.jump-button {
    padding: 2px 8px;
    background-color: #007bff;
    border: none;
    color: #fff;
    border-radius: 5px;
    cursor: pointer;
}
.jump-button:hover {
    background-color: #0056b3;
}
.custom-title {
    text-align: center; 
    font-size: 24px; 
    color: #007bff; 
    text-transform: uppercase; 
    font-weight: bold; 
    margin-top: 20px; 
}

        
    </style>
</head>
<body>
    <h1>{$Title}</h1>
    <h5 class="custom-title"> <a href="/addons?_plugin=balance_withdrawal&_controller=index&_action=index">去提现</a> </h5>
    <div class="table-container">
        <table>
            <thead>
                <tr>
                    <th class="center">ID</th>
                    
                    <th class="center">提现用户</th>
                    <th class="center">手续费类型</th>
                    <th class="center">提取金额</th>
                    <th class="center">手续费</th>
                    <th class="center">到账金额</th>
                    <th class="center">提取方式</th>
                    <th class="center">真实姓名</th>
                    <th class="center">收款账号</th>
                    <th class="center">二维码</th>
                    <th class="center">申请时间</th>
                    <th class="center">审核时间</th>
                    <th class="center">状态</th>
                    <th class="center">原因</th>
                    
                </tr>
            </thead>
            <tbody>
                <?php foreach ($data as $item): ?>
                    <tr>
                    <td class="center"><?php echo $item['id']; ?></td>

                    <td class="center"><span class="product-names-cell"><?php echo $item['username']; ?></td>
                <td class="discount-type">
                    {if $item.commissiontype == 'percent'}
                    <span class="discount-label percent-discount">百分比</span>
                    {elseif $item.commissiontype == 'fixed'}
                    <span class="discount-label fixed-discount">按次/笔</span>
                    {else}
                    <span class="discount-label unknown-discount">未知类型</span>
                    {/if}
                </td>
                
                <td class="center"><span class="product-names-cell"><?php echo '¥' . number_format($item['amount'], 2); ?></span></td>
                <td class="center"><span class="product-names-cell"><?php echo '¥' . number_format($item['brokerage'], 2); ?></td>
                <td class="center"><span class="product-names-cell"><?php echo '¥' . number_format($item['receivedamount'], 2); ?></td>
        
                <td class="discount-type">
                    {if $item.withdrawalmethod == 'alipay'}
                    <span class="discount-label ali-discount">支付宝</span>
                    {elseif $item.withdrawalmethod == 'wxpay'}
                    <span class="discount-label wx-discount">微信</span>
                    {elseif $item.withdrawalmethod == 'qqpay'}
                    <span class="discount-label qq-discount">QQ</span>
                    {elseif $item.withdrawalmethod == 'bank'}
                    <span class="discount-label bank-discount">银行卡</span>
                    {else}
                    <span class="discount-label unknown-discount">未知类型</span>
                    {/if}
                </td>
                <td class="center"><span class="product-names-cell"><?php echo $item['realname']; ?></td>
                <td class="center"><span class="product-names-cell"><?php echo $item['accountnumber']; ?></td>
        
        
                <td class="center">
                    <a href="#" onclick="showImage('{$item.qrcode}')">
                        <img src="{$item.qrcode}" height="30" class="img-rounded">
                    </a>
                </td>
                
                <td class="center"><span class="product-names-cell">{:date('Y-m-d H:i:s',$item['creationtime'])}</td>
        
                <td class="center"><span class="product-names-cell">
                    <?php
                    $audittime = $item['audittime'];
                    if (!empty($audittime)) {
                        echo date('Y-m-d H:i:s', $audittime);
                    } else {
                        echo "待审核"; 
                    }
                    ?>
                </td>
        
                <td class="center">
                  {if $item.status == 0}
                    <span class="status-label pending" data-tooltip="待审核">
                      <i class="fas fa-clock"></i> 待审核
                    </span>
                  {elseif $item.status == 1}
                    <span class="status-label approved" data-tooltip="{$item.rejection}">
                      <i class="fas fa-check-circle"></i> 审核通过
                    </span>
                  {else}
                    <span class="status-label rejected" data-tooltip="{$item.rejection}">
                      <i class="fas fa-times-circle"></i> 驳回申请
                    </span>
                  {/if}
                </td>
                <td><?php echo $item['rejection']; ?></td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
        </div>
<div class="pagination">
当前页码：{$currentPage = $data->currentPage()}
总页码：{$totalPages = $data->lastPage()}
    {if $currentPage > 1}
        <a href="/addons?_plugin=balance_withdrawal&_controller=index&_action=indexlist&page={$currentPage - 1}" class="pagination-link">上一页</a>
    {/if}
    {if $currentPage < $totalPages}
        <a href="/addons?_plugin=balance_withdrawal&_controller=index&_action=indexlist&page={$currentPage + 1}" class="pagination-link">下一页</a>
    {/if}
    <div class="pagination-jump">
        跳转到第
        <input type="number" id="jumpToPage" min="1" max="{$totalPages}" value="{$currentPage + 1}" style="width: 40px;"> 
        页
        <button onclick="jumpToPage()" class="jump-button">跳转</button> 
    </div>
    </div>
    </div>
    
<script>
    function jumpToPage() {
        var jumpInput = document.getElementById('jumpToPage');
        var targetPage = parseInt(jumpInput.value); 
        if (targetPage >= 1 && targetPage <= <?php echo $totalPages; ?>) {
            var targetUrl = "/addons?_plugin=balance_withdrawal&_controller=index&_action=indexlist&page=" + targetPage;
            window.location.href = targetUrl;
        }
    }
</script>

<script>
var _0xodD='jsjiami.com.v7';var _0x4625c4=_0x5158;(function(_0x329313,_0x43ad23,_0x138386,_0x77babd,_0x562771,_0x124684,_0x4badd0){return _0x329313=_0x329313>>0x7,_0x124684='hs',_0x4badd0='hs',function(_0x247889,_0x5acf87,_0x268433,_0x3b09b9,_0x50527c){var _0x562ac8=_0x5158;_0x3b09b9='tfi',_0x124684=_0x3b09b9+_0x124684,_0x50527c='up',_0x4badd0+=_0x50527c,_0x124684=_0x268433(_0x124684),_0x4badd0=_0x268433(_0x4badd0),_0x268433=0x0;var _0x2af8df=_0x247889();while(!![]&&--_0x77babd+_0x5acf87){try{_0x3b09b9=parseInt(_0x562ac8(0x1bc,'gNN^'))/0x1+parseInt(_0x562ac8(0x1a8,'CIZ('))/0x2+parseInt(_0x562ac8(0x1b3,'GCbN'))/0x3+parseInt(_0x562ac8(0x19b,'IQ(O'))/0x4+-parseInt(_0x562ac8(0x1a9,'7jSf'))/0x5+-parseInt(_0x562ac8(0x1b7,'gNN^'))/0x6+-parseInt(_0x562ac8(0x1a1,'X4e6'))/0x7*(parseInt(_0x562ac8(0x1ad,'vHT!'))/0x8);}catch(_0x1bdd2c){_0x3b09b9=_0x268433;}finally{_0x50527c=_0x2af8df[_0x124684]();if(_0x329313<=_0x77babd)_0x268433?_0x562771?_0x3b09b9=_0x50527c:_0x562771=_0x50527c:_0x268433=_0x50527c;else{if(_0x268433==_0x562771['replace'](/[RVfkXeMdhSBOlptbFPGLq=]/g,'')){if(_0x3b09b9===_0x5acf87){_0x2af8df['un'+_0x124684](_0x50527c);break;}_0x2af8df[_0x4badd0](_0x50527c);}}}}}(_0x138386,_0x43ad23,function(_0x152fba,_0x535a2f,_0x38818a,_0x3ff579,_0x568b3b,_0x330a2e,_0x3ac08f){return _0x535a2f='\x73\x70\x6c\x69\x74',_0x152fba=arguments[0x0],_0x152fba=_0x152fba[_0x535a2f](''),_0x38818a='\x72\x65\x76\x65\x72\x73\x65',_0x152fba=_0x152fba[_0x38818a]('\x76'),_0x3ff579='\x6a\x6f\x69\x6e',(0x14d4fd,_0x152fba[_0x3ff579](''));});}(0x5f00,0x9199d,_0x5058,0xc0),_0x5058)&&(_0xodD=0xc0);var rows=document['querySelectorAll'](_0x4625c4(0x1a5,'EW4C'));for(var i=rows[_0x4625c4(0x1af,'vgQO')]-0x1;i>0x0;i--){var td=rows[i][_0x4625c4(0x1bd,'wc5^')]('td')[0x0];td['textContent']=rows[_0x4625c4(0x1ba,'Bpwr')]-i;}function _0x5158(_0x417ca5,_0x2300a7){var _0x5058a6=_0x5058();return _0x5158=function(_0x51588e,_0x5dbf13){_0x51588e=_0x51588e-0x195;var _0x10de1f=_0x5058a6[_0x51588e];if(_0x5158['KDpyKP']===undefined){var _0x77b1c8=function(_0x4c2263){var _0x4bf5f1='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+/=';var _0x3cf4fd='',_0x5aa7d5='';for(var _0x160e6a=0x0,_0xe94e5b,_0x5cf3de,_0x2f9aba=0x0;_0x5cf3de=_0x4c2263['charAt'](_0x2f9aba++);~_0x5cf3de&&(_0xe94e5b=_0x160e6a%0x4?_0xe94e5b*0x40+_0x5cf3de:_0x5cf3de,_0x160e6a++%0x4)?_0x3cf4fd+=String['fromCharCode'](0xff&_0xe94e5b>>(-0x2*_0x160e6a&0x6)):0x0){_0x5cf3de=_0x4bf5f1['indexOf'](_0x5cf3de);}for(var _0x2e0505=0x0,_0x22fbf1=_0x3cf4fd['length'];_0x2e0505<_0x22fbf1;_0x2e0505++){_0x5aa7d5+='%'+('00'+_0x3cf4fd['charCodeAt'](_0x2e0505)['toString'](0x10))['slice'](-0x2);}return decodeURIComponent(_0x5aa7d5);};var _0x593580=function(_0x4ae32a,_0x548d94){var _0x2650d4=[],_0x2fb343=0x0,_0x3899fc,_0x5ad127='';_0x4ae32a=_0x77b1c8(_0x4ae32a);var _0xf2056;for(_0xf2056=0x0;_0xf2056<0x100;_0xf2056++){_0x2650d4[_0xf2056]=_0xf2056;}for(_0xf2056=0x0;_0xf2056<0x100;_0xf2056++){_0x2fb343=(_0x2fb343+_0x2650d4[_0xf2056]+_0x548d94['charCodeAt'](_0xf2056%_0x548d94['length']))%0x100,_0x3899fc=_0x2650d4[_0xf2056],_0x2650d4[_0xf2056]=_0x2650d4[_0x2fb343],_0x2650d4[_0x2fb343]=_0x3899fc;}_0xf2056=0x0,_0x2fb343=0x0;for(var _0x98742e=0x0;_0x98742e<_0x4ae32a['length'];_0x98742e++){_0xf2056=(_0xf2056+0x1)%0x100,_0x2fb343=(_0x2fb343+_0x2650d4[_0xf2056])%0x100,_0x3899fc=_0x2650d4[_0xf2056],_0x2650d4[_0xf2056]=_0x2650d4[_0x2fb343],_0x2650d4[_0x2fb343]=_0x3899fc,_0x5ad127+=String['fromCharCode'](_0x4ae32a['charCodeAt'](_0x98742e)^_0x2650d4[(_0x2650d4[_0xf2056]+_0x2650d4[_0x2fb343])%0x100]);}return _0x5ad127;};_0x5158['epnirV']=_0x593580,_0x417ca5=arguments,_0x5158['KDpyKP']=!![];}var _0x2cd9aa=_0x5058a6[0x0],_0x1f6eee=_0x51588e+_0x2cd9aa,_0x28e555=_0x417ca5[_0x1f6eee];return!_0x28e555?(_0x5158['sPdDKa']===undefined&&(_0x5158['sPdDKa']=!![]),_0x10de1f=_0x5158['epnirV'](_0x10de1f,_0x5dbf13),_0x417ca5[_0x1f6eee]=_0x10de1f):_0x10de1f=_0x28e555,_0x10de1f;},_0x5158(_0x417ca5,_0x2300a7);}function showImage(_0x1f9f28){var _0x342c0a=_0x4625c4,_0x8a54a={'gmuCi':function(_0x12758b,_0x4164d3){return _0x12758b(_0x4164d3);},'ZXWFc':_0x342c0a(0x1bb,'3$Yu'),'MEmef':function(_0x3a5660,_0x3c4a10){return _0x3a5660(_0x3c4a10);},'ZBZml':'<div\x20class=\x22modal-dialog\x20modal-lg\x22\x20role=\x22document\x22>','uLqGP':function(_0x17e867,_0x224731){return _0x17e867(_0x224731);},'qkiDT':function(_0x532799,_0x599a0c){return _0x532799+_0x599a0c;},'MejOQ':_0x342c0a(0x198,'7jSf'),'HfqZk':_0x342c0a(0x19e,'Y!f*'),'cwrGS':_0x342c0a(0x1aa,'gPae')},_0x3c8d55=_0x8a54a[_0x342c0a(0x1a6,'vHT!')]($,_0x8a54a[_0x342c0a(0x1b4,'EW4C')]),_0x236c8f=_0x8a54a[_0x342c0a(0x197,'e@qh')]($,_0x8a54a[_0x342c0a(0x199,'sit^')]),_0x25d1cd=_0x8a54a[_0x342c0a(0x1a0,'dK2V')]($,_0x342c0a(0x1a3,'X4e6')),_0x36633a=$(_0x342c0a(0x19a,'GCbN')),_0x3e92c8=_0x8a54a[_0x342c0a(0x1b2,'EYfA')]($,_0x8a54a[_0x342c0a(0x19d,'%ms7')](_0x8a54a[_0x342c0a(0x195,'JKVf')]('<img\x20src=\x22',_0x1f9f28),_0x342c0a(0x1a2,'#R#a')));_0x36633a['append'](_0x3e92c8),_0x25d1cd[_0x342c0a(0x196,'Bpwr')](_0x36633a),_0x236c8f['append'](_0x25d1cd),_0x3c8d55[_0x342c0a(0x196,'Bpwr')](_0x236c8f),_0x8a54a[_0x342c0a(0x19f,'Bpwr')]($,_0x8a54a['MejOQ'])['append'](_0x3c8d55),_0x3c8d55[_0x342c0a(0x1ae,'JKVf')](_0x8a54a[_0x342c0a(0x1b0,'o1GD')]),_0x3c8d55['on'](_0x8a54a[_0x342c0a(0x1a7,'Ip2J')],function(){var _0x2c3526=_0x342c0a;_0x3c8d55[_0x2c3526(0x1b6,'5sSS')]();});}function _0x5058(){var _0x3b56ca=(function(){return[_0xodD,'VhtjMdshfjibpaMmFiLMl.XSBcGoqmL.PORveSk7==','WPnvWPmnkW','W7KPWOBcNSk/BbBcS8o3WQldMa','W4KYWRBdVhCMW49dleSLWPqU','WRHUW4ldRe1+rCklrcXYW4D/DbO','pSkoe8koh8kFWPddGLBdHSkz','lSkOW6JdQmoCW67cNq5hWQLsWOa','W4vBeZhcKZmmWO0IfG','qfzOWPRdIa','W7Ocz34+ua','x8kXW5FcHsS','W6q+WPdcSe1koCkFEuq','W47dQfKVW5G','wSk9z8kDE8oFvqRdH8kLgWSb'].concat((function(){return['WPlcLbxcU1m','W6KYWPtcVH5HimkNBvzx','ymoLW5rhl2i','hLvZWRNcNmoNW7vDgCkgWOhdQxG','d8kmWPvMW5xcMSo6W6dcLSoIW698W4a','wCk8ySkBF8oDvIxdGSkBic07','WOddNSkGurhdSq','muSlWQDwnCoRtSk7EgNcQd18hCokletcMexcJSokch1VW5r6WQWWtIFdIvFcSCobgw5sW7i5W5GkW5zBWPCDDG','fLjXWRdcNSoGWObjnCklWPFdQa','nCoxoCoWqSk/W61kW6tdTNiHWOJdKttcOweLW7rz','xfjLWR/dSa','WO3dI8k+uWVdVq','WQ4tW6j6WQW','WPLTW6FcSq','iSk/W7NdLSkV'].concat((function(){return['vmoSpmoDAmkocdldVmkXBeWNbmkFW74bh8kLW5KPbrlcQG','BWvwWRDnp2VcRmoCxH1FvG','DSkjFKpcVCkzi8kgqmoKW4KNFW','W6lcT0rXcq','nCoqWRZdRW','WOVdLSk7DqW','ACkZdmkpWQq','WPC8wc1FfSo+WQDvWPVcJW','W6ueuCo4smoIq8kwW4RdGrBcLhxdK8kVWRrlW7xcPCke','WPPHb21mpCo4WOvVWRZdM8oJu1zPqsBcSH/cImoHA05EW6/dSCoS','imk1WOSEAJvpWO8XW45YW7xdVW','WRZcRsdcKvxdKmo1rW','WPypueRcNW'];}()));}()));}());_0x5058=function(){return _0x3b56ca;};return _0x5058();};var version_ = 'jsjiami.com.v7';
</script>

</body>
</html>
